# Dsactive la mise en veille de l'ordinateur et des crans
powercfg /change standby-timeout-ac 0
powercfg /change monitor-timeout-ac 0

# Charge le module Forms de PowerShell
Add-Type -AssemblyName System.Windows.Forms

# Rcupre la fentre PowerShell actuelle
$consoleWindow = [System.Windows.Forms.Screen]::FromHandle((Get-Process -Id $PID).MainWindowHandle).Bounds

# Dfinit les constantes ncessaires
Add-Type @"
    using System;
    using System.Runtime.InteropServices;

    public class MouseInput {
        [DllImport("user32.dll", SetLastError = true)]
        public static extern void mouse_event(uint dwFlags, uint dx, uint dy, uint dwData, IntPtr dwExtraInfo);

        public const uint MOUSEEVENTF_LEFTDOWN = 0x0002;
        public const uint MOUSEEVENTF_LEFTUP = 0x0004;
    }
"@

# Fonction pour effectuer un clic gauche
function SimulerClicGauche {
    [MouseInput]::mouse_event([MouseInput]::MOUSEEVENTF_LEFTDOWN, 0, 0, 0, [System.IntPtr]::Zero)
    Start-Sleep -Milliseconds 100  # Ajustez la dure si ncessaire
    [MouseInput]::mouse_event([MouseInput]::MOUSEEVENTF_LEFTUP, 0, 0, 0, [System.IntPtr]::Zero)
}

Write-Host "Logiciel anti-flicage tltravail version 2.0"
Write-Host "Code par Antoine @ 1formatik.com"
Write-Host "--------------------------------------------------"

# Demande  l'utilisateur les valeurs des plages horaires
$matinDebut = Read-Host "Entrez l'heure de dbut pour la plage horaire du matin (par exemple, 9h00)"
$matinFin = Read-Host "Entrez l'heure de fin pour la plage horaire du matin (par exemple, 12h30)"
$apresmidiDebut = Read-Host "Entrez l'heure de dbut pour la plage horaire de l'aprs-midi (par exemple, 14h00)"
$apresmidiFin = Read-Host "Entrez l'heure de fin pour la plage horaire de l'aprs-midi (par exemple, 17h30)"

Write-Host "--------------------------------------------------"
Write-Host "La souris bouge automatiquement entre $matinDebut et $matinFin puis entre $apresmidiDebut et $apresmidiFin"
Write-Host "--------------------------------------------------"
Write-Host "Pour arrter le logiciel lorsque la souris bouge, maintenez la touche CTRL et appuyez sur la touche C"

while ($true) {
    $var_heureActuelle = Get-Date
    $var_matinDebut = Get-Date -Hour ($matinDebut.Split('h')[0]) -Minute ($matinDebut.Split('h')[1] -split ':' | Select-Object -Index 0) -Second 0
    $var_matinFin = Get-Date -Hour ($matinFin.Split('h')[0]) -Minute ($matinFin.Split('h')[1] -split ':' | Select-Object -Index 0) -Second 0
    $var_apresmidiDebut = Get-Date -Hour ($apresmidiDebut.Split('h')[0]) -Minute ($apresmidiDebut.Split('h')[1] -split ':' | Select-Object -Index 0) -Second 0
    $var_apresmidiFin = Get-Date -Hour ($apresmidiFin.Split('h')[0]) -Minute ($apresmidiFin.Split('h')[1] -split ':' | Select-Object -Index 0) -Second 0
    
    # Vrifie si l'heure actuelle est en dehors des deux plages horaires
    if (($var_heureActuelle -lt $var_matinDebut -or $var_heureActuelle -ge $var_matinFin) -and ($var_heureActuelle -lt $var_apresmidiDebut -or $var_heureActuelle -ge $var_apresmidiFin)) 
	{
        # Si on est en dehors des plages horaires, on attend 60 secondes avant de revrifier
        Start-Sleep -Seconds 60
    }
    else 
	{
        # Si on est dans les plages horaires, on bouge la souris
        $centerX = $consoleWindow.Left + ($consoleWindow.Width / 2)
        $centerY = $consoleWindow.Top + ($consoleWindow.Height / 2)

        $angle = 0
        $radius = 75  # Rayon du cercle (demi-diamtre)

		while ($angle -lt 360) 
		{
			$x = [math]::sin($angle * [math]::PI / 180) * $radius
			$y = [math]::cos($angle * [math]::PI / 180) * $radius

			$x += $centerX
			$y += $centerY

			[System.Windows.Forms.Cursor]::Position = New-Object System.Drawing.Point([math]::Round($x), [math]::Round($y))

			Start-Sleep -Milliseconds 10  # Ajuste la dure pour changer la vitesse du mouvement
			$angle += 1
		}

		# Envoie le clic gauche  la fin de la rotation complte
		Start-Sleep -Milliseconds 100
		SimulerClicGauche
		Start-Sleep -Milliseconds 10000

    }
}